library orm_domain;

import 'package:dorm/dorm.dart';
import 'package:observe/observe.dart';

part 'employee.dart';
part 'immutable_entity.dart';
part 'job.dart';
part 'mutable_entity.dart';
part 'person.dart';
part 'user.dart';

void ormInitialize() {
	EntityAssembler assembler = new EntityAssembler();

	assembler.scan(Employee, 'entities.employee', Employee.construct);
	assembler.scan(ImmutableEntity, 'entities.immutable_entity', ImmutableEntity.construct);
	assembler.scan(Job, 'entities.job', Job.construct);
	assembler.scan(MutableEntity, 'entities.mutable_entity', MutableEntity.construct);
	assembler.scan(Person, 'entities.person', Person.construct);
	assembler.scan(User, 'entities.user', User.construct);
}
